; * Mestrado em Matemática e Computação
; * Projecto de Dissertação - Ano lectivo de 2011/2013
; *      - Bounded Model Checking para uma Linguagem Imperativa Simples
; * Realizado por:
; *      - José João Peixoto Pereira   - pg17312@alunos.uminho.pt
; * Professores Orientadores:
; *      - Luís Filipe Ribeiro Pinto   - Departamento de Matemática
; *      - Jorge Sousa Pinto           - Departamento de Informática
; * Em conformidade com o standard SMT-LIB v2.0
; *      - \url{goedel.cs.uiowa.edu/smtlib/papers/smt-lib-reference-v2.0-r10.03.30.pdf}

; * Options:
(set-option :print-success true)

; * Declarations:

; * Assertions:
; *     set(C) -> set(P) === not_set(C) or set(P)
; *     is there a not (set(C)->set(P))? not(not_set(C) or set(P)) === set(C) and not_set(P)
(assert (and ; set(C), the Codification of the Program
         true 

 (not ; not_set(P) the Codification of the Conditions
         (or  (not  true )  true )

)))
; * 
; * Computation:
; *     - Check satisfiability
(check-sat)
(get-model) ; -- A formula is unsatisfiable if it does not have any model.
(exit)
