<html>
    <head>
        <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
    </head>
<body>
    
<?php
    $program_src = "program.src";
    $program_dsl = "program.dsl";
    $program_smt = "program.smt";
    $program_tex = "program.tex";

?>

<?php
//setlocale(LC_ALL, 0);
$console = "";
$integrity = 1;
if(isset($_POST['program'])){
//    exec("rm program.pdf");
//    exec("rm program.smt");
//    exec("rm program.tex");
//    exec("rm program.src");
    
    
    /* saving the file*/
    $handle = fopen($program_src, 'w+') or die("cant create:$program_src");
    fwrite($handle,$_POST['program']);
    fclose($handle);
    
    /*
     * Block of integrity
     */
    if($integrity == 1){
        $io_dsl = shell_exec("bin/parser.bin < $program_src 2>&1");
        if (preg_match("/.*error.*/", $io_dsl, $matches)) {
            $console .= "[Phase 1]-[ERROR]: Code error.\n";
            $console .= "engine.bin: ".$matches[0]."\n";
            
            $integrity = 0;
        }else{
            $console .= "[Phase 1]-[Ok]: Successful generation of DSL file.\n\n";
            $handle = fopen($program_dsl, 'w+') or die("cant create: $program_dsl");
            fwrite($handle,$io_dsl);
            fclose($handle);
        }
    }
    

    /*
     * Block of integrity
     */
    if($integrity == 1){
        $io_smt = shell_exec("bin/engine.bin smt 2>&1");
        if (preg_match("/error/i", $io_smt, $matches)) {
            $console .= "[Phase 2]-[ERROR]: Code error.\n";
            $console .= $io_smt."\n";
            
            $integrity = 0;
        }else{
            $console .= "[Phase 2]-[Ok]: Successful generation of SMT-LIB v2.0 file.\n\n";
            $handle = fopen($program_smt, 'w+') or die("cant create: $program_smt");
            fwrite($handle,$io_smt);
            fclose($handle);
        }
    }

    /*
     * Block of integrity
     */
    if($integrity == 1){
        $io_tex = shell_exec("bin/engine.bin tex 2>&1");
        if (preg_match("/error/i", $io_tex, $matches)) {
            $console .= "[Phase 3]-[ERROR]: Code error.\n";
            $console .= $io_tex."\n";
            
            $integrity = 0;
        }else{
            $console .= "[Phase 3]-[Ok]: Successful generation of LaTeX2e file.\n\n";
            $handle = fopen($program_tex, 'w+') or die("cant create: $program_tex");
            fwrite($handle,$io_tex);
            fclose($handle);

            /*
             * If new Latex document
             */
            $io_latex = shell_exec("/usr/texbin/pdflatex $program_tex 2>&1");
            if (preg_match("/Fatal error occurred/", $io_latex, $matches)) {
                $console .= "[Phase 4]-[ERROR]: Latex NOT generated.\n";
            }else{
                $io_latex = shell_exec("/usr/texbin/pdflatex $program_tex 2>&1");
                if (preg_match("/Fatal error occurred/", $io_latex, $matches)) {
                    $console .= "[Phase 4]-[ERROR]: Latex NOT generated.\n";
                }else{
                    $console .= "[Phase 5]-[Ok]: Latex report generated.\n\n";
                    $generated_pdf = 1;
                }
            }
        }
    }
    
}else{
    $console .= "Hello, welcome to this project.\n";
    $console .= "\n";
    $console .= "Edit your program,\n";
    $console .= "and then press the button [Evaluate with BMC]\n";
    $console .= "\n";
    $console .= "Please report your findings to pg17312@alunos.uminho.pt\n";
    $console .= "\n";
    $console .= "Regards.\n";
}
?>
<form action="index.php" method=POST>
    <table>
        <tr>
            <td colspan="2">
                <hr />
            </td>
        </tr>                
        <tr>
            <td>
                <input type="submit" value="Evaluate with BMC"/>
            </td>
            <td>
                [ <a target="_blank" href="http://rise4fun.com/z3">SMT Prover Z3 - External link</a> ]
<?php if($generated_pdf == 1){
          echo "[ <a target=\"_blank\" href=\"program.pdf\">Download pdf file</a> ]";
}?>
                
            </td>
        </tr>
        <tr>
            <td colspan="2">
<hr />
<font size="1">Console:</font><br />
<textarea name="console" rows="10" cols="164">
<?php echo $console; ?>
</textarea>
<hr />
            </td>
        </tr>
        <tr>
            <td>
<font size="1">Program:</font><br />
<textarea name="program" rows="40" cols="1">
<?php
for($i=0;$i<40;$i++){echo $i."\n";}
?>
</textarea>
<textarea name="program" rows="40" cols="78">
<?php
    $handle = fopen($program_src, 'r+') or die("cant read $program_src");
    if($handle){
        while(!feof($handle)){
            echo fgets($handle);
        }
        fclose($handle);
    }
?>
</textarea>
            </td>
            <td>
<font size="1">SMT-LIB v2.0:</font><br />
<textarea name="smt-lib2.0" rows="40" cols="78">
<?php
    if($integrity == 1){
        $handle = fopen($program_smt, 'r+');
        if($handle){
            while(!feof($handle)){
              echo fgets($handle);
            }
            fclose($handle);
        }
    }
?>
</textarea>
            </td>
        </tr>
    </table>
</form>
</body>
</html>