; * Mestrado em Matemática e Computação
; * Projecto de Dissertação - Ano lectivo de 2011/2013
; *      - Bounded Model Checking para uma Linguagem Imperativa Simples
; * Realizado por:
; *      - José João Peixoto Pereira   - pg17312@alunos.uminho.pt
; * Professores Orientadores:
; *      - Luís Filipe Ribeiro Pinto   - Departamento de Matemática
; *      - Jorge Sousa Pinto           - Departamento de Informática
; * Em conformidade com o standard SMT-LIB v2.0
; *      - \url{goedel.cs.uiowa.edu/smtlib/papers/smt-lib-reference-v2.0-r10.03.30.pdf}

; * Options:
(set-option :print-success true)

; * Declarations:
(declare-const x1 Int)
(declare-const x0 Int)
(declare-const x2 Int)
(declare-const x3 Int)
(declare-const x4 Int)
(declare-const x5 Int)

; * Assertions:
; *     set(C) -> set(P) === not_set(C) or set(P)
; *     is there a not (set(C)->set(P))? not(not_set(C) or set(P)) === set(C) and not_set(P)
(assert (and ; set(C), the Codification of the Program
     (and 
         (or  (not  (and  true  false ))  (=  x1  x0 ))
     (and 
         (or  (not  (and  (and  true  false ) false ))  (=  x2  x1 ))
     (and 
         (or  (not  (and  (and  (and  true  false ) false ) false ))  (=  x3  x2 ))
     (and 
         (or  (not  (and  (and  (and  (and  true  false ) false ) false ) false ))  (=  x4  x3 ))
     (and 
         (or  (not  (and  (and  (and  (and  true  false ) false ) false ) false ))  (=  x5  x4 ))
     (and 
         (or  (not  (and  (and  (and  (and  true  false ) false ) false ) (not  false ) ))  (=  x5  x3 ))
     (and 
         (or  (not  (and  (and  (and  true  false ) false ) false ))  (=  x4  x3 ))
     (and 
         (or  (not  (and  (and  (and  true  false ) false ) (not  false ) ))  (=  x4  x2 ))
     (and 
         (or  (not  (and  (and  true  false ) false ))  (=  x3  x2 ))
         (or  (not  (and  (and  true  false ) (not  false ) ))  (=  x3  x1 ))
)))))))))
 (not ; not_set(P) the Codification of the Conditions
         (or  (not  (and  (and  (and  (and  true  false ) false ) false ) false ))  (not  false ) )

)))
; * 
; * Computation:
; *     - Check satisfiability
(check-sat)
(get-model) ; -- A formula is unsatisfiable if it does not have any model.
(exit)
